/********************************************************
 * Data Visualization - 2D Matrix Demo                  *
 * Tested in Processing 3                               *     
 *                                                      *
 * Author: Rodger (Jieliang) Luo                        *
 * Supervisor: George Legrady                           *
 *                                                      *
 * Purpose: Demonstrate how to make a simple 2D Matrix  *
 *          data visualization with different color     *
 *          schemes.                                    *
 *                                                      *
 * Usage:                                               *
 *          Press '1', '2', '3', '4' to apply different *
 *          color schemes.                              *
 *          Press '0' to use gray scale.                *
 ********************************************************/

/*
Step One: Upload CSV to Table & Get basic information of data. 
 Step Two: Write data from Table to 2D Array & Have max and min value of data.
 Step Three: Visualize 2D Matrix.
 Step Four: Draw labels and title.
 */
 
 int Y_AXIS = 1;
int X_AXIS = 2;



final float margin_left = 180;
final float margin_top = 70;

final float margin_left2 = 680;
final float margin_top2 = 70;

final float margin_left3 = 680;
final float margin_top3 = 350;

final float margin_left4 = 180;
final float margin_top4 = 350;

int[] years;
int[] years2;
int[] years3;
int[] years4;


float cell_width, cell_height;

Table all_data; 
Table all_data2;
Table all_data3;
Table all_data4;

int  rows, cols;
int rows2, cols2;
int rows3, cols3;
int rows4, cols4;


float[][] data_matrix; 
float[][] data_matrix2; 
float[][] data_matrix3; 
 float[][] data_matrix4; 

float max, min;

color checkout_color;

void setup() {
  size(1280, 720); 
  
 

  all_data = loadTable("LeviathanHoriz.csv", "header");
  all_data2 = loadTable("RepublicHoriz.csv", "header");
  all_data3 = loadTable("CapitalHoriz.csv", "header");
    all_data4 = loadTable("CommHoriz.csv", "header");
  
  rows = all_data.getRowCount ();
  cols = all_data.getColumnCount ();
  
  rows2 = all_data2.getRowCount ();
  cols2 = all_data2.getColumnCount ();
  
   rows3 = all_data3.getRowCount ();
  cols3 = all_data3.getColumnCount ();
  
    rows4 = all_data4.getRowCount ();
  cols4 = all_data4.getColumnCount ();

  data_matrix = new float[rows][cols-1];
  years = new int[rows];
  
   data_matrix2 = new float[rows][cols2-1];
  years2 = new int[rows];
  
   data_matrix3 = new float[rows][cols3-1];
  years3 = new int[rows];
  
  data_matrix4 = new float[rows][cols4-1];
  years4 = new int[rows];
  
  ///////////////////////////

  for (int i=0; i<data_matrix.length; i++) {
    for (int j=0; j<data_matrix[0].length; j++) {
      data_matrix[i][j] = log(all_data.getFloat(i, j+1)+1);
    }
  }
  //get max and min data from the array
  for (int i=0; i<data_matrix.length; i++) {
    for (int j=0; j<data_matrix[0].length; j++) {
      if (data_matrix [i][j] > max) { 
        max = data_matrix[i][j];
      }
    }
  }
   /////////////// end G1 setup
    
    for (int a=0; a<data_matrix2.length; a++) {
    for (int b=0; b<data_matrix2[0].length; b++) {
      data_matrix2[a][b] = log(all_data2.getFloat(a, b+1)+1);
    }
  }
  //get max and min data from the array
  for (int a=0; a<data_matrix2.length; a++) {
    for (int b=0; b<data_matrix2[0].length; b++) {
      if (data_matrix2 [a][b] > max) { 
        max = data_matrix2[a][b];
      }
      }
    }
    
    /////////////////////end G2 setup
    
     for (int c=0; c<data_matrix3.length; c++) {
    for (int d=0; d<data_matrix3[0].length; d++) {
      data_matrix3[c][d] = log(all_data3.getFloat(c, d+1)+1);
    }
  }
  ////get max and min data from the array
  for (int c=0; c<data_matrix3.length; c++) {
    for (int d=0; d<data_matrix3[0].length; d++) {
      if (data_matrix3 [c][d] > max) { 
        max = data_matrix3[c][d];
      }
      }
    }
    
    //////////////end G3 setup
    
    for (int e=0; e<data_matrix4.length; e++) {
    for (int f=0; f<data_matrix4[0].length; f++) {
      data_matrix4[e][f] = log(all_data4.getFloat(e, f+1)+1);
    }
  }
  ////get max and min data from the array
  for (int e=0; e<data_matrix4.length; e++) {
    for (int f=0; f<data_matrix4[0].length; f++) {
      if (data_matrix4 [e][f] > max) { 
        max = data_matrix4[e][f];
      }
      }
    }
    
    ///////////end G4 setup
    
    
  
  min = 0;
  println("Max: " + max);
  println("Min: " + min);

  cell_width = (margin_left *2) / cols;
  cell_height = (height - margin_top *2) / rows;
  noLoop();
}

void draw() {  
  // println(hour() + ":" + minute() + ":" + second());
  //draw 2d Matrixxxx

  background (0);
 
  
  

  for (int i=0; i<data_matrix.length; i++) {
    for (int j=0; j<data_matrix[0].length; j++) {
     

      checkout_color = (int) map(data_matrix[i][j], min, max, 255, 0);
      stroke (255);
      fill(checkout_color);
      rect(margin_left + j*cell_width, margin_top + i*cell_height/2.5, cell_width, 80);
      
    }
  
  }
  fill (255);
  textSize (20);
 // text ("Title",220,30);
 // text ("Checkouts",400,30);
 // text ("Year",800,30);
  pushMatrix();
  translate(140, 100);
  rotate(HALF_PI*9);
  text("Leviathan",0,0);
  popMatrix();
  
  
  
  noStroke();
  fill(0);
  rect(170 ,70, 380, 50);
  
  
   for(int i=0; i<12; i++){
    int year = 2006;
    textSize(15);
    fill(255);
  pushMatrix();
  translate(495, -120);
   rotate(PI/2.0);
    
    text(year+i, 220, 28 * i);
    popMatrix();
    
    for(int x=0; x<320; x+=28){
      stroke (255);
      int gap = 195;
      line (x+gap, 150, x+gap, 185);
    }
   }
   /////////////end of G1
   
   for (int a=0; a<data_matrix.length; a++) {
    for (int b=0; b<data_matrix[0].length; b++) {
     

      checkout_color = (int) map(data_matrix2[a][b], min, max, 255, 0);
      stroke (255);
      fill(checkout_color);
      rect(margin_left2 + b*cell_width, margin_top + a*cell_height/2.5, cell_width, 80);
      
    }
  
  }
  
  fill (255);
  textSize (20);
 // text ("Title",220,30);
 // text ("Checkouts",400,30);
 // text ("Year",800,30);
  pushMatrix();
  translate(640, 100);
  rotate(HALF_PI*9);
  text("Republic",0,0);
  popMatrix();
  
 // line(width/2, 0, width/2, 720);
 // line(0, height/2, 1280, height/2);
  
  noStroke();
  fill(0);
  rect(670 ,70, 380, 50);
  
  
   for(int i=0; i<12; i++){
    int year = 2006;
    textSize(15);
    fill(255);
  pushMatrix();
  translate(995, -120);
   rotate(PI/2.0);
    
    text(year+i, 220, 28 * i);
    popMatrix();
    
    for(int x=0; x<320; x+=28){
      stroke (255);
      int gap = 695;
      line (x+gap, 150, x+gap, 185);
    }
   }
  
  /////////////end of G2
  
   for (int c=0; c<data_matrix3.length; c++) {
    for (int d=0;d<data_matrix3[0].length; d++) {
     

      checkout_color = (int) map(data_matrix3[c][d], min, max, 255, 0);
      stroke (255);
      fill(checkout_color);
      rect(margin_left3 + d*cell_width, margin_top3 + c*cell_height/2.5, cell_width, 80);
      
    }
  
  }
  
   fill (255);
  textSize (20);
 // text ("Title",220,30);
 // text ("Checkouts",400,30);
 // text ("Year",800,30);
  pushMatrix();
  translate(640, 370);
  rotate(HALF_PI*9);
  text("Capital",0,0);
  popMatrix();
  
  
  noStroke();
  fill(0);
  rect(670 ,350, 380, 50);
  
  
   for(int i=0; i<12; i++){
    int year = 2006;
    textSize(15);
    fill(255);
  pushMatrix();
  translate(995, 160);
   rotate(PI/2.0);
    
    text(year+i, 220, 28 * i);
    popMatrix();
    
    for(int x=0; x<320; x+=28){
      stroke (255);
      int gap = 695;
      line (x+gap, 430, x+gap, 465);
    }
   }
   /////////////end of G3
   
for (int e=0; e<data_matrix4.length; e++) {
    for (int f=0;f<data_matrix4[0].length; f++) {
     

      checkout_color = (int) map(data_matrix4[e][f], min, max, 255, 0);
      stroke (255);
      fill(checkout_color);
      rect(margin_left4 + f*cell_width, margin_top4 + e*cell_height/2.5, cell_width, 80);
      
    }
  
  }
  
   fill (255);
  textSize (20);
 // text ("Title",220,30);
 // text ("Checkouts",400,30);
 // text ("Year",800,30);
  pushMatrix();
  translate(140, 370);
  rotate(HALF_PI*9);
  text("Communist",0,0);
  popMatrix();
  pushMatrix();
  translate(115, 370);
  rotate(HALF_PI*9);
  text("Manifesto",0,0);
  popMatrix();

  
  noStroke();
  fill(0);
  rect(170 ,350, 380, 50);
  
  
   for(int i=0; i<12; i++){
    int year = 2006;
    textSize(15);
    fill(255);
  pushMatrix();
  translate(495, 160);
   rotate(PI/2.0);
    
    text(year+i, 220, 28 * i);
    popMatrix();
    
    for(int x=0; x<320; x+=28){
      stroke (255);
      int gap = 195;
      line (x+gap, 430, x+gap, 465);
    }
   
   }  
   /////////end G4
   //fill(255);
  rect (1100, 100, 20, 300);
  textSize(20);
  text("0", 1140, 115);
  text("100", 1140, 400);
   //gradientRect(140, 630, 200, 20, b1, b2);
   textSize(30);
   text("Popular Political Texts Over Time", 180, 650);
}